/*---------------------------------------------------------------------------*/
//       Author : hiyohiyo
//         Mail : hiyohiyo@crystalmark.info
//          Web : http://crystalmark.info/
//      License : The modified BSD license
//
//                                Copyright 2002- hiyohiyo All rights reserved.
/*---------------------------------------------------------------------------*/
#include "stdafx.h"
#include "crystalcpuid.h"
#include "CrystalCPUIDDlg.h"
#include "LoveHammerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static CCrystalCPUIDDlg* P;

/////////////////////////////////////////////////////////////////////////////
// CLoveHammerDlg Dialog

CLoveHammerDlg::CLoveHammerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLoveHammerDlg::IDD, pParent)
{
	P = (CCrystalCPUIDDlg*)pParent;
	//{{AFX_DATA_INIT(CLoveHammerDlg)
	m_CurrentFID = _T("");
	m_CurrentVID = _T("");
	m_MaxFID = _T("");
	m_MaxVID = _T("");
	m_StartupFID = _T("");
	m_StartupVID = _T("");
	//}}AFX_DATA_INIT

	m_VID = 0;
}

void CLoveHammerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLoveHammerDlg)
	DDX_Control(pDX, IDC_LH_VOLTAGE_DOWN, m_VoltageDown);
	DDX_Control(pDX, IDC_LH_VOLTAGE_UP, m_VoltageUp);
	DDX_Control(pDX, IDC_LH_VOLTAGE_MESSAGE, m_VoltageMessage);
	DDX_Control(pDX, IDC_LH_SET_FID, m_SetFID);
	DDX_Text(pDX, IDC_LH_CURRENT_FID, m_CurrentFID);
	DDX_Text(pDX, IDC_LH_CURRENT_VID, m_CurrentVID);
	DDX_Text(pDX, IDC_LH_MAX_FID, m_MaxFID);
	DDX_Text(pDX, IDC_LH_MAX_VID, m_MaxVID);
	DDX_Text(pDX, IDC_LH_STARTUP_FID, m_StartupFID);
	DDX_Text(pDX, IDC_LH_STARTUP_VID, m_StartupVID);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CLoveHammerDlg, CDialog)
	//{{AFX_MSG_MAP(CLoveHammerDlg)
	ON_CBN_SELCHANGE(IDC_LH_SET_FID, OnSelchangeLhSetFid)
	ON_BN_CLICKED(IDC_LH_VOLTAGE_UP, OnLhVoltageUp)
	ON_BN_CLICKED(IDC_LH_VOLTAGE_DOWN, OnLhVoltageDown)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CLoveHammerDlg::OnCancel() 
{
	CDialog::OnCancel();
}

void CLoveHammerDlg::OnOK() 
{
	CDialog::OnOK();
}

void CLoveHammerDlg::Refresh()
{
	DWORD data;
	char str[256];

	// Init Current Status
	P->SysInfo->GetData(LH_GET_CURRENT_STATUS, &data);

	m_CurrentFID = P->SysInfo->GetInfo(LH_GET_CURRENT_MULTIPLIER,str);
	m_StartupFID = P->SysInfo->GetInfo(LH_GET_STARTUP_MULTIPLIER,str);
	m_MaxFID     = P->SysInfo->GetInfo(LH_GET_MAX_MULTIPLIER,str);

	if( m_type == 8 ){
		m_CurrentVID = P->SysInfo->GetInfo(LH_GET_CURRENT_VOLTAGE,str);
		m_StartupVID = P->SysInfo->GetInfo(LH_GET_STARTUP_VOLTAGE,str);
		m_MaxVID     = P->SysInfo->GetInfo(LH_GET_MAX_VOLTAGE,str);

		P->SysInfo->GetData(LH_GET_CURRENT_VID, &m_VID);

		if( m_VID == 0 ){
			m_VoltageUp.EnableWindow(FALSE);
		}else{
			m_VoltageUp.EnableWindow(TRUE);
		}

		if( m_VID == 30 ){
			m_VoltageDown.EnableWindow(FALSE);
		}else{
			m_VoltageDown.EnableWindow(TRUE);
		}
	}

	UpdateData(FALSE);
	UpdateWindow();
}

BOOL CLoveHammerDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	CString cstr;
	double d;
	DWORD id = 0;
	DWORD data;

	// Init ComboBox
	P->SysInfo->GetData(LH_GET_TYPE, &m_type);
	if( m_type == 8 ){
		for(d = 4.0; d <= 25.0; d += 0.5){
			cstr.Format("x %.1f",d);
			m_SetFID.AddString(cstr);
		}
	}else if( m_type == 7 ){
		static BYTE MultiTableMobileAthlon[32]={22, 23, 24, 25, 10, 11, 12, 13, 
												14, 15, 16, 17, 18, 19, 20, 21,
												 6, 38,  8, 40, 26, 27, 28, 42, 
												30, 44, 32, 33, 34, 36, 46, 48};
		for(int i = 0; i < 32; i++ ){
			cstr.Format("x %.1f", MultiTableMobileAthlon[i] / 2.0 );
			m_SetFID.AddString(cstr);
		}
		m_VoltageUp.EnableWindow(FALSE);
		m_VoltageDown.EnableWindow(FALSE);
		m_VoltageMessage.EnableWindow(FALSE);
	}

	// Init Current Status
	P->SysInfo->GetData(LH_GET_CURRENT_STATUS, &data);
	
	P->SysInfo->GetData(LH_GET_CURRNET_FID,&id);
	m_SetFID.SetCurSel(id);

	Refresh();

	return TRUE;
}

void CLoveHammerDlg::OnSelchangeLhSetFid() 
{
	P->SysInfo->SetData(LH_SET_FID,m_SetFID.GetCurSel());
	Refresh();
	P->Refresh(TRUE);
}

void CLoveHammerDlg::OnLhVoltageUp() 
{
	m_VID--;
	if(m_VID <= 0){m_VID = 0;} // 1.550V
	P->SysInfo->SetData(LH_SET_VID, m_VID );
	Refresh();
}

void CLoveHammerDlg::OnLhVoltageDown() 
{
	m_VID++;
	if(m_VID >= 30){m_VID = 30;} // 0.800V
	P->SysInfo->SetData(LH_SET_VID, m_VID );
	Refresh();
}
